// FileDialog.cpp
// Neuron Computing Inc.
#include "Dlg_Common.h"

#include <stdio.h>
#include <dirent.h>

static int find_extension_in_file_name(char *file, char *extension)
{
	char buf[256];
	sprintf(buf,".%s", extension);
	int len_file = strlen((char*)file);
	int len_ext  = strlen((char*)buf);
	int to = len_file - len_ext + 1;
	for (int k=0; k<to; k++)
	{
		char* temp = (char*)(file + k);
		if (strcmp((char*)buf, temp) == 0)
			return 1;
	}
	return 0;
}
 
int Dlg_File::choose_file_to_read(char *prompt, char *extension,
                                    char *file_name)
{
	int numFiles = 0;
	DIR *dirp;
	struct dirent *dp;
	char* fileNames[512];
	dirp = opendir(".");
	if (dirp != 0)
	{
		while ((dp = readdir(dirp)) != 0)
		{
			if (strlen(extension) < 1 || 
				find_extension_in_file_name(dp->d_name,extension))
			{
				if (numFiles < 498)
				{
					// Insert the file in the correct (sorted position):
					int inserted = 0;
					for (int m=0; m<numFiles; m++)
					{
						char* temp = (char*)fileNames[m];
						if (strcmp((char*)dp->d_name, temp)<=0 &&
                            inserted == 0)
						{
							int k;
							for (k=(numFiles-1); k>=m; k--)
								fileNames[k+1] = fileNames[k];
							int len = strlen((char *)(dp->d_name));
							fileNames[m] = new char[len + 1];
							for (k=0; k<len; k++)
								fileNames[m][k] = dp->d_name[k];
							fileNames[m][len] = '\0';
							numFiles++;
							inserted = 1;
						}
					}
					if (inserted == 0)
					{
						int len = strlen((char *)(dp->d_name));
						fileNames[numFiles] = new char[len + 1];
						for (int k=0; k<len; k++)
							fileNames[numFiles][k] = dp->d_name[k];
						fileNames[numFiles][len] = '\0';
						numFiles++;
					}
				}
			}
		}
	}
	Dlg_List dlg;
	dlg.m_parent = m_parent;
	int response = dlg.choose_one_from_list(prompt, fileNames, numFiles);
	if (response > -1)
	{
		sprintf(file_name, "%s", fileNames[response]);
    }
	else
	{
		file_name[0] = '\0';
	}
	for (int k=0; k<numFiles; k++)
		delete fileNames[k];
	if (strlen(file_name) > 0)
		return 0;
	else
		return 1;
}

int Dlg_File::choose_file_to_write(char *prompt, char *file_name)
{
	Dlg_Edit dlg;
	dlg.m_parent = m_parent;
	dlg.do_edit(prompt, file_name);
	if (strlen(file_name) > 0)
		return 0;
	else
		return 1;
}
